diff -r -c -b -B -N cosmomc/source/cmbtypes.F90 cosmomc_addon/source/cmbtypes.F90
*** cosmomc/source/cmbtypes.F90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/cmbtypes.F90	2009-10-28 12:02:35.376021546 +0100
***************
*** 0 ****
--- 1,425 ----
+ !Define the data types and read/writes them to disk. Also change l_max here.
+ 
+ module cmbtypes
+ use settings
+ implicit none
+ 
+ 
+ !Number of Cls, 1 for just temperature, 3 (4) for polarization (with B)
+   integer, parameter  :: num_cls  = 3
+ 
+ !l_max. Tensors are not computed unless compute_tensors = T in input file
+ !Make these multiples of 50, should be 50 more than you need accurately
+   integer, parameter :: lmax = 2100, lmax_tensor = 400
+ 
+ !Parameters for calculating/storing the matter power spectrum
+ !Note that by default everything is linear
+ !Old mpk settings
+ #ifdef DR71RG
+ !!! BR09: Reid et al 2009 settings for the LRG power spectrum.
+   integer, parameter :: num_matter_power = 300 !number of points computed in matter power spectrum
+   real, parameter    :: matter_power_minkh =  0.999e-4  !minimum value of k/h to store
+   real, parameter    :: matter_power_dlnkh = 0.03     !log spacing in k/h
+   real, parameter    :: matter_power_maxz = 0.
+   integer, parameter :: matter_power_lnzsteps = 4  ! z=0 to get sigma8 (this first entry appears to be coded in some spots in the code!!), plus 3 LRG redshifts.
+ #else
+   integer, parameter :: num_matter_power = 74 !number of points computed in matter power spectrum
+   real, parameter    :: matter_power_minkh =  0.999e-4  !1e-4 !minimum value of k/h to store
+   real, parameter    :: matter_power_dlnkh = 0.143911568     !log spacing in k/h
+   real, parameter    :: matter_power_maxz = 0.    !6.0
+   integer, parameter :: matter_power_lnzsteps = 1 !20
+ #endif
+ !Only used in params_CMB
+    real :: pivot_k = 0.05 !Point for defining primordial power spectra
+    logical :: inflation_consistency = .false. !fix n_T or not
+ 
+         !Note these are the interpolated/extrapolated values. The k at which matter power is computed up to 
+         !by CAMB is set in CMB_Cls_xxx with, e.g. P%Transfer%kmax = 0.6 (which is enough for 2dF)
+ 
+ !Number of scalar-only cls
+ !if num_cls=4 and CMB_lensing then increased to 4 
+   integer :: num_clsS=min(num_cls,3) 
+ 
+   integer, parameter :: norm_As=1, norm_amp_ratio=2, norm_freq_ix = 3
+   
+   Type CMBParams
+      real nuisance(1:num_nuisance_params)
+       !unit Gaussians for experimental parameters
+      real norm(1:num_norm)
+       !These are fast parameters controling amplitudes, calibrations, etc.
+      real InitPower(1:num_initpower)
+       !These are fast paramters for the initial power spectrum
+      !Now remaining (non-independent) parameters
+      real omb, omc, omv, omnu, omk, omdm
+      real ombh2, omch2, omnuh2, omdmh2
+      real zre, nufrac
+      real h, H0
+      real w
+      real reserved(5)
+   
+   end Type CMBParams
+ 
+   Type CosmoTheory
+      real Age, r10
+      real SN_loglike, HST_loglike, BAO_loglike, reserved(1)
+      real cl(lmax,num_cls), cl_tensor(lmax_tensor,num_cls) !TT, TE, EE and BB  in that order
+      real sigma_8
+      real matter_power(num_matter_power,matter_power_lnzsteps)
+        !second index is redshifts from 0 to matter_power_maxz
+        !if custom_redshift_steps = false with equal spacing in
+        !log(1+z) and matter_power_lnzsteps points
+        !if custom_redshift_steps = true set in mpk.f90 
+      ! BR09 additions
+      real mpk_nw(num_matter_power,matter_power_lnzsteps) !no wiggles fit to matter power spectrum
+      real mpkrat_nw_nl(num_matter_power,matter_power_lnzsteps) !halofit run on mpk_nw
+      real finalLRGtheoryPk(num_matter_power)  !! this is the quantity that enters the LRG likelihood calculation
+     ! end BR09 additions
+   end Type CosmoTheory
+ 
+   logical, parameter ::  Old_format  = .false.
+   logical, parameter :: write_all_Cls = .false. 
+    !if false use CAMB's flat interpolation scheme (lossless if models are flat except near lmax when lensed)
+ 
+ contains
+ 
+ 
+    subroutine WriteModel(i,CMB, T, like, mult)
+     integer i
+     real, intent(in), optional :: mult
+     Type(CosmoTheory) T
+     real like, amult
+     Type(CMBParams) CMB
+     integer j 
+ 
+     if (present(mult)) then
+        amult = mult
+     else
+        amult = 1
+     end if
+     
+     if (Old_format) then
+ 
+       stop 'old not supported'    
+     else
+ 
+     j = 0 !format ID
+     if (write_all_cls) j=1
+     write(i) j
+ 
+     write(i) amult, num_matter_power, lmax, lmax_tensor, num_cls
+ 
+     write(i) T%SN_loglike, T%HST_loglike, T%reserved
+ 
+     write(i) like
+     write(i) CMB
+ 
+     write(i) T%Age, T%r10, T%sigma_8, T%matter_power
+ 
+     if (write_all_cls) then
+      write(i) T%cl(2:lmax,1:num_cls)
+      write(i) T%cl_tensor(2:lmax_tensor,1:num_cls)
+     else
+ 
+        !Use interpolation scheme CAMB uses for flat models
+        !If using significantly non-flat, or increasing interpolation accuracy, save all th cls instead
+         write(i) T%cl(2:20,1:num_cls)
+         do j=30,90,10 
+          write(i) T%cl(j,1:num_cls)
+         end do
+         do j=110,130, 20
+          write(i) T%cl(j,1:num_cls)
+         end do
+         do j=150,lmax, 50
+          write(i) T%cl(j,1:num_cls)
+         end do
+ 
+         if (lmax_tensor /= 0) then
+             if (lmax_tensor<150) stop 'lmax_tensor too small'
+             write(i) T%cl_tensor(2:20,1:num_cls)
+             do j=30,90,10 
+              write(i) T%cl_tensor(j,1:num_cls)
+             end do
+             do j=110,130,20 
+              write(i) T%cl_tensor(j,1:num_cls)
+             end do
+             do j=150,lmax_tensor, 50
+              write(i) T%cl_tensor(j,1:num_cls)
+             end do
+         end if
+     end if
+ 
+     end if 
+ 
+     if (flush_write) call FlushFile(i)
+ 
+    end subroutine WriteModel
+ 
+    
+  subroutine ReadModel(i,CMB, T, mult, like, error)
+     integer, intent(in) :: i
+     integer, intent(out) :: error
+     real, intent(out) :: mult
+     Type(CosmoTheory) T
+     real like
+     Type(CMBParams) CMB
+     real icl(lmax,1:num_cls)
+     integer allcl,j,ind, ix(lmax)
+     integer almax,almaxtensor, anumpowers, anumcls
+    
+     error = 0
+ 
+     if (old_format) then
+ 
+        stop 'old not supported'
+ 
+     else
+ 
+         read(i,end=100,err=100) allcl
+ 
+         if (allcl/=0 .and. allcl/=1) stop 'wrong file format'
+ 
+         read(i,end=100,err=100) mult,anumpowers,almax, almaxtensor, anumcls
+         if (almax > lmax) stop 'reading file with larger lmax'
+         if (anumcls > num_cls) stop 'reading file with more Cls (polarization)'
+ 
+         read(i) T%SN_loglike, T%HST_loglike,T%reserved
+    
+         read(i,end = 100, err=100) like
+         read(i) CMB
+ 
+     
+         read(i) T%Age, T%r10, T%sigma_8, T%matter_power(1:anumpowers,1:matter_power_lnzsteps)
+         T%cl = 0
+         T%cl_tensor = 0
+          
+         if(allcl==1) then  
+          read(i) T%cl(2:almax,1:anumcls)
+          read(i) T%cl_tensor(2:almaxtensor,1:anumcls)
+         else
+ 
+             read(i) icl(1:19,1:num_cls)
+             ind =1
+             do j =2,20 
+                ix(ind)=j
+                ind=ind+1
+             end do
+             do j=30,90,10 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+              do j=110,130,20 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+             do j=150,almax, 50
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind+1
+             end do
+             ind = ind-1
+  
+            call InterpCls(ix,icl, T%cl, ind, almax, num_Cls)
+ 
+            if (almaxtensor /= 0) then     
+             read(i) icl(1:19,1:num_cls)
+             ind =1
+             do j =2,20 
+                ix(ind)=j
+                ind=ind+1
+             end do
+             do j=30,90,10 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+             do j=110,130,20 
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind + 1
+             end do
+             do j=150,almaxtensor, 50
+              read(i) icl(ind,1:num_cls)
+              ix(ind) = j
+              ind = ind+1
+             end do
+             ind = ind-1
+             call InterpCls(ix,icl, T%cl_tensor, ind, almaxtensor,num_cls)
+            end if
+         
+         end if 
+ 
+         return
+     100 error = 1
+ 
+     end if
+ 
+    end subroutine ReadModel
+ 
+       subroutine InterpCls(l,iCl, all_Cl, n, almax, ncls)
+       integer, intent(in) :: n, almax,ncls
+    
+       real, intent(in) :: iCl(lmax,1:num_cls)
+       integer l(n),p
+       real all_Cl(:,:)
+    
+       integer il,llo,lhi,xi
+       real xl(n),  ddCl(n)
+ 
+       real a0,b0,ho
+       real inCl(n)
+ 
+     
+       do p =1, ncls
+ 
+         do il=1,n
+            inCl(il) = iCl(il,p)*l(il)**2
+         end do
+ 
+         xl = l
+         call spline_real(xl,inCl,n,ddCl)
+      
+         llo=1
+         do il=2,l(n)
+            xi=il
+            if ((xi > l(llo+1)).and.(llo < n)) then
+               llo=llo+1
+            end if
+            lhi=llo+1
+            ho=l(lhi)-l(llo)
+            a0=(xl(lhi)-xi)/ho
+            b0=(xi-xl(llo))/ho
+           
+            all_Cl(il,p) = (a0*inCl(llo)+ b0*inCl(lhi)+((a0**3-a0)* ddCl(llo) &
+                    +(b0**3-b0)*ddCl(lhi))*ho**2/6)/il**2
+   
+         end do
+ 
+       end do
+ 
+       all_Cl(l(n)+1:almax,:) = 0
+        
+ 
+       end subroutine InterpCls
+   
+   
+    subroutine ClsFromTheoryData(T, CMB, Cls)
+      Type(CosmoTheory) T
+      Type(CMBParams) CMB
+      real Cls(lmax,num_cls)
+      integer i
+      
+      Cls(2:lmax,1:num_clsS) =T%cl(2:lmax,1:num_clsS)    !CMB%norm(norm_As)*T%cl(2:lmax,1:num_clsS)
+      if (num_cls>3 .and. num_ClsS==3) Cls(2:lmax,num_cls)=0
+ 
+      i = norm_amp_ratio !this convolution is to avoid compile-time bounds-check errors on CMB%norm
+      if (CMB%norm(i) /= 0) then
+         Cls(2:lmax_tensor,:) =  Cls(2:lmax_tensor,:)+ T%cl_tensor(2:lmax_tensor,:) 
+          !CMB%norm(norm_As)*CMB%norm(norm_amp_ratio)*T%cl_tensor(2:lmax_tensor,:)
+      end if 
+ 
+    end subroutine ClsFromTheoryData
+ 
+    subroutine WriteTextCls(aname,T, CMB)
+      Type(CosmoTheory) T
+      Type(CMBParams) CMB
+      character (LEN=*), intent(in) :: aname
+      integer l
+      real Cls(lmax,num_cls)
+ 
+      call ClsFromTheoryData(T,CMB,Cls)
+      open(unit = tmp_file_unit, file = aname, form='formatted', status = 'replace')
+      do l=2, lmax
+         write (tmp_file_unit,*) l, Cls(l,:)*l*(l+1)/(2*pi)
+      end do
+      close(tmp_file_unit)
+ 
+    end subroutine WriteTextCls
+ 
+    function MatterPowerAt(T,kh)
+      !get matter power spectrum today at kh = k/h by interpolation from stored values
+      real, intent(in) :: kh
+      Type(CosmoTheory) T
+      real MatterPowerAt
+      real x, d
+      integer i
+    
+      x = log(kh/matter_power_minkh) / matter_power_dlnkh
+      if (x < 0 .or. x >= num_matter_power-1) then
+         write (*,*) ' k/h out of bounds in MatterPowerAt (',kh,')'
+         stop 
+      end if
+      i = int(x)
+      d = x - i
+      MatterPowerAt = exp(log(T%matter_power(i+1,1))*(1-d) &
+        + log(T%matter_power(i+2,1))*d)
+      !Just do linear interpolation in logs for now..
+      !(since we already cublic-spline interpolated to get the stored values)
+      !Assume matter_power_lnzsteps is at redshift zero
+    end function
+ 
+ 
+ 
+ !BR09 this function is just a copy of the one above but with LRG theory put in instead of linear theory
+    function LRGPowerAt(T,kh)
+      !get LRG matter power spectrum today at kh = k/h by interpolation from stored values
+      real, intent(in) :: kh
+      Type(CosmoTheory) T
+      real LRGPowerAt
+      real x, d
+      integer i
+    
+      x = log(kh/matter_power_minkh) / matter_power_dlnkh
+      if (x < 0 .or. x >= num_matter_power-1) then
+         write (*,*) ' k/h out of bounds in MatterPowerAt (',kh,')'
+         stop 
+      end if
+      i = int(x)
+      d = x - i
+      LRGPowerAt = exp(log(T%finalLRGtheoryPk(i+1))*(1-d) + log(T%finalLRGtheoryPk(i+2))*d)
+      !Just do linear interpolation in logs for now..
+      !(since we already cublic-spline interpolated to get the stored values)
+    end function
+ !!BRO09 addition end
+ 
+    function MatterPowerAt_Z(T,kh,z)
+      !get matter power spectrum at z at kh = k/h by interpolation from stored values
+ 
+      real, intent(in) :: kh
+      Type(CosmoTheory) T
+      real MatterPowerAt_Z
+      real x, d, z, y, dz, mup, mdn
+      real matter_power_dlnz
+      integer i, iz
+    
+      matter_power_dlnz = log(matter_power_maxz+1) / (matter_power_lnzsteps -1 + 1e-13)
+      y = log(1.+ z) / matter_power_dlnz 
+ 
+      if (z > matter_power_maxz ) then
+         write (*,*) ' z out of bounds in MatterPowerAt_Z (',z,')'
+         stop
+      end if
+      x = log(kh/matter_power_minkh) / matter_power_dlnkh
+      if (x < 0 .or. x >= num_matter_power-1) then
+         write (*,*) ' k/h out of bounds in MatterPowerAt_Z (',kh,')'
+         stop
+      end if
+ 
+      iz = int(y*0.99999999)
+      dz = y - iz
+ 
+      i = int(x)
+      d = x - i
+ 
+      mup = log(T%matter_power(i+1,iz+2))*(1-d) + log(T%matter_power(i+2,iz+2))*d
+      mdn = log(T%matter_power(i+1,iz+1))*(1-d) + log(T%matter_power(i+2,iz+1))*d
+ 
+      MatterPowerAt_Z = exp(mdn*(1-dz) + mup*dz)
+ 
+    end function MatterPowerAt_Z
+ 
+ 
+ 
+ 
+ end module cmbtypes
diff -r -c -b -B -N cosmomc/source/distparams.ini cosmomc_addon/source/distparams.ini
*** cosmomc/source/distparams.ini	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/distparams.ini	2009-10-27 18:08:06.060876506 +0100
***************
*** 0 ****
--- 1,133 ----
+ #Params for "getdist" - for processing .txt chain information
+ 
+ #if zero, columnnum calculated automatically as total number of columns
+ columnnum  = 0
+ 
+ file_root = chains/test
+ out_root = 
+ out_dir = 
+ plot_data_dir = plot_data/
+ 
+ #if parameter_names empty set from file_root.paramnames if it exists
+ #otherwise set up labels manually in this file using lab1=... etc.
+ parameter_names = 
+ #params_CMB.paramnames
+ 
+ 
+ #If generated chain at higher temperature can cool for computing results
+ cool = 1
+ 
+ #If 0 assume 1 and no chain filename prefixes
+ chain_num = 6
+ first_chain = 
+ exclude_chain = 
+ 
+ #width of Gaussian smoothing - Should check plots are robust to changes in 
+ #this parameter. Narrow diagonal distributions need larger number
+ #Can also check plots by comparing with setting smoothing=F below
+ num_bins = 20
+ 
+ #For disgarding burn-in if using raw chains
+ #if < 1 interpreted as a fraction of the total number of rows (0.3 ignores first 30% of lines)
+ ignore_rows = 0.5
+ 
+ #if T produced B&W printer friendly output
+ B&W = F
+ #version of MatLab you are using
+ matlab_version = 7
+ 
+ #Switches; auto_label labels all parameters by their number
+ no_plots = F
+ no_tests = F
+ auto_label = F
+ #samples_are_chains = F can be useful for other samples when first two columns not present
+ samples_are_chains = T
+ 
+ #Include these in 1D plots for comparison - must have same parameters
+ compare_num = 0
+ compare1 = basic6_cmb
+ 
+ plot_meanlikes = T
+ shade_meanlikes = T
+ td_meanlikes = F
+ 
+ # if non-zero, output _thin file, thinned by thin_factor
+ thin_factor = 0
+ #Do probabilistic importance sampling to single samples
+ make_single_samples = F
+ single_thin = 4
+ 
+ #Do simple importance sampling
+ adjust_priors = F
+ #Map parameters to other derived quantities
+ map_params = F
+ 
+ #Use a Gaussian smoothing with width of the bin size
+ #Otherwise use top hat bins
+ smoothing = T
+ 
+ num_contours = 2
+ contour1 = 0.68
+ contour2 = 0.95
+ 
+ do_minimal_1d_intervals = F
+ 
+ #if we only want 2D plots agains a particular variable
+ plot_2D_param = 0
+ 
+ #if above zero, instead plot just these combinations:
+ #if both zero it will plot most correlated variables
+ plot_2D_num = 0
+ plot1 = ns omegabh2
+ plot2 =
+ 
+ #number of sample plots, colored by third parameter
+ #if last parameter is 0 or -1 colored by the parameter most correlated
+ #with one of the eigenvector directions (e.g. parallel or orthogonal to degeneracy)
+ num_3D_plots = 1
+ 3D_plot1 = H0 omegam tau
+ 
+ #Output 2D plots for param combos with 1D marginalized plots along the diagonal
+ triangle_plot = T
+ 
+ #Number of parameters to get covariance matrix for
+ #set automatically from parameter names file by default 
+ #If you are going to use the output as a proposal density make sure
+ #you have map_params = F, and the dimension equal to the number of MCMC parameters
+ cov_matrix_dimension = 
+ 
+ #e.g. colormap('jet')
+ matlab_colscheme =
+ 
+ #Parameters to use. If zero use all parameters which have lables.
+ plotparams_num = 0
+ plotparams = omegabh2 omegadmh2 tau ns
+ 
+ #Get set label to empty to not include a parameter in the parameter_names file
+ #lab[asz]=
+ 
+ #marker[x] adds vertical line to MatLab 1D plot
+ marker[nrun] = 0
+ 
+ #Need to give limits if prior cuts off distribution where not very small
+ limits[tau] = 0.01 N
+ limits[fnu] = 0 N
+ limits[w] = -1 N
+ limits[r]= 0 N
+ limits[asz] = 0 2
+ 
+ #all_limits sets all limitsxx for all variables to the same; can be useful for bins
+ all_limits = 
+ 
+ #compute two-tail marginalized limits irrespective of limits settings above
+ #(otherwise limits are two-tail only for those parameters without limits)
+ force_twotail = F
+ 
+ #PCA - analysis output in file file_root.PCA
+ #number of parameter to do PCA for
+ PCA_num = 0
+ PCA_normparam = omegam
+ #The parameters to use
+ PCA_params = omegam H0 tau
+ #L for log(x), M for log(-x), N for no log
+ PCA_func   = LLL
diff -r -c -b -B -N cosmomc/source/driver.F90 cosmomc_addon/source/driver.F90
*** cosmomc/source/driver.F90	2009-10-20 15:24:17.000000000 +0200
--- cosmomc_addon/source/driver.F90	2009-10-27 18:13:18.549876476 +0100
***************
*** 58,68 ****
  
  #ifdef MPI 
  
!         if (instance /= 0) call DoStop('With MPI should not have second parameter')
          call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
  
          instance = MPIrank +1 !start at 1 for chains                                             
!         write (numstr,*) instance
          rand_inst = instance
          if (ierror/=MPI_SUCCESS) call DoStop('MPI fail')
  
--- 58,77 ----
  
  #ifdef MPI 
  
! !addon
! !        if (instance /= 0) call DoStop('With MPI should not have second parameter')
!         instance_shift=instance
!         write(*,*)'MPI file names shifted by: ',instance_shift
! !end addon
          call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
  
          instance = MPIrank +1 !start at 1 for chains                                             
! !addon
! !        write (numstr,*) instance
!          instance_shift = MPIrank + instance_shift
!          write (numstr,*) instance_shift
! !end addon
! 
          rand_inst = instance
          if (ierror/=MPI_SUCCESS) call DoStop('MPI fail')
  
***************
*** 85,90 ****
--- 94,104 ----
  
          propose_scale = Ini_Read_Real('propose_scale',2.4)
          AccuracyLevel = Ini_Read_Real('accuracy_level',1.)
+ !addon
+         lAccuracyLevel = Ini_Read_Real('l_accuracy_level',1.)
+         lSampleLevel = Ini_Read_Real('l_sample_level',1.)
+         CambComputeEveryl = Ini_Read_Logical('camb_compute_every_l',.false.)
+ !end addon
  
          checkpoint = Ini_Read_Logical('checkpoint',.false.)
          if (checkpoint) flush_write = .true.
